package com.game 
{
	import flash.display.CapsStyle;
	import flash.display.Sprite;
	import flash.utils.Endian;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Canvas;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	import net.flashpunk.tweens.misc.ColorTween;
	
	import com.hud.IdeaButton;
	import com.hud.TextWindow;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Tween;
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author ...
	 */
	public class MainGame extends World
	{
		private var pitchField:TextWindow;
		
		private var timer:Tween;
		private var storyButtons:Array;
		
		private var buttonsArea:Rectangle;
		
		/*Sprites*/
		private var scenePlayer:LDScene;
		private var sceneBoss:LDScene;
		private var logoSpt:Entity;
		
		/*States*/
		private var playingCutscene:Boolean;
		private var gameFinished:Boolean;
		
		private var fader:Entity;
		
		private var textTimer:TextWindow;
		private var counter:int;
		private var maxTime:int;
		private var ideaTime:int;
		
		private var story:StoryPlayer;
		
		private var hud:Entity;
		
		private var ideaSpeed:Number;
		private var canvas1:Canvas;
		private var canvas2:Canvas;
		private var entCanvas:Entity; //for deletion
		
		private var points:int;
		private var maxPoints:int;
		
		private var shadowText:ShadowedText;
		
		private var fadeTween:ColorTween;
		
		private var musicFx:Sfx;
		private var whatFx:Sfx;
		private var primFx:Sfx;
		private var playerFx:Sfx;		
		
		private var replayBtn:TextWindow;
		
		public function MainGame() 
		{
			maxTime = 300;
			
			story = null;
			
			playingCutscene = true;
			gameFinished = false;
			
			loadGraphics();
			
			WordDatabase.instance().loadWords();
			maxPoints = 5;
			WordDatabase.instance().buildPhrase(maxPoints, "It's a");			
			
			fader = new Entity();
			canvas2 = new Canvas(800, 480);
			canvas2.fill(new Rectangle(0, 0, 800, 480), 0x000000);
			fader.graphic = canvas2;
			
			this.add(fader);
			fadeTween = new ColorTween(playIntro);
			fadeTween.tween(100, 0xffffff, 0xffffff, 1, 0);
			
			fader.addTween(fadeTween, true);
			
			replayBtn = new TextWindow(280, 50, 0x4800FF, 2, 0xffffff, 40); 
			replayBtn.text = "PLAY AGAIN?";
			
			replayBtn.x = 260;
			replayBtn.y = 260;
			
		//	playIntro();
		//	startGame();
		}
		
		public function loadGraphics():void
		{
			hud = new Entity();
			
			scenePlayer = new LDScene();
			scenePlayer.startWithBg(BackgroundAssets.BG1, 
						new Spritemap(SpriteAssets.SPRITEPLAYER, SpriteAssets.playerDimensions.width, SpriteAssets.playerDimensions.height)); 
			
			scenePlayer.actor.x =  400-130;
			scenePlayer.actor.y = 175;
			
			scenePlayer.actor.add("blink", [1, 0, 1, 0], 0.1, false);
			scenePlayer.actor.add("happy", [2]);
			scenePlayer.actor.add("reading", [3]);
			scenePlayer.actor.add("lookpaper", [6,7]);
			scenePlayer.actor.add("nervous", [4, 5], 0.05);
			scenePlayer.actor.add("look", [8, 9, 8, 9], 0.05, false);			
			scenePlayer.actor.add("sad", [10]);
			
			sceneBoss = new LDScene();
			sceneBoss.startWithBg(BackgroundAssets.BG2, 
						new Spritemap(SpriteAssets.SPRITEEVIL1, SpriteAssets.evil1Dimensions.width, SpriteAssets.evil1Dimensions.height)); 
						
			sceneBoss.actor.x = 400-130;
			sceneBoss.actor.y = 120;		
			
			sceneBoss.actor.add("happy", [0]);	
			sceneBoss.actor.add("happy2", [7]);	
			sceneBoss.actor.add("neutral", [2]);
			sceneBoss.actor.add("bad", [3]);
			sceneBoss.actor.add("talk", [6]);
			sceneBoss.actor.add("scream", [4, 5], 0.2, false );
			sceneBoss.actor.add("blink", [8, 3, 8, 3], 0.2, false);
			
			sceneBoss.actor.play("bad");
			
			this.add(scenePlayer);
			this.add(sceneBoss);
			
			pitchField = new TextWindow(800, 100, 0x0026FF, 2, 0xffffff);
			
			this.add(pitchField);
			pitchField.x = 0;
			pitchField.y = 400;
			
			pitchField.text = "";							
			
			whatFx = new Sfx(Sounds.SFX_BOSSWHAT, removeWhatText);
			primFx = new Sfx(Sounds.PRIM);
			playerFx = new Sfx(Sounds.PLAYER);
		}
		
		public function playIntro():void
		{
			this.remove(fader);
			story = new StoryPlayer();
			story.worldPtr = this;
			
			canvas1 = new Canvas(800, 480);
			entCanvas = this.addGraphic(canvas1);
			
			this.remove(pitchField);
			this.add(pitchField);
			
			story.setCanvas(canvas1);
			story.setTextWindow(pitchField);
			
			story.setScene(sceneBoss);
			story.queue("", "", 10);
			story.queue("blink", "", 60);
			story.queueScene(scenePlayer);
			story.queue("", "", 50);
			story.queue("blink", "", 10);
			story.queue("", "Your boss asked you for a game idea but you have nothing.", 180, Sounds.NARR1);
			story.queue("", "Guess you gonna have to make something up right now!", 180, Sounds.NARR2);
			story.queueScene(sceneBoss);
			story.queue("", "I've heard he likes " + WordDatabase.instance().getLikesPhrase(4)+". Try to put those things in your game!" , 260, Sounds.NARR3);
			story.queue("blink", "", 40);
			story.queue("talk", "You have 10 seconds!", 120, Sounds.SFX_BOSS1);
			story.queueScene(scenePlayer);
			story.queue("lookpaper", "...", 10, null, showLogo);
			
			story.play();
		}
		
		public function showLogo():void
		{
			logoSpt = new Entity();
			logoSpt.graphic = new Image(SpriteAssets.SPRITETITLE);
			this.add(logoSpt);
			blinkStart();
			
			var logoFx:Sfx = new Sfx(Sounds.TAMDAM);
			logoFx.play(1);
		}
		
		public function blinkStart():void
		{
			fadeTween = new ColorTween(startGameDelay);
			fadeTween.tween(20, 0xffffff, 0xffffff, 1, 0);
			
			canvas2.fill(new Rectangle(0, 0, 800, 480), 0xffffff);
			canvas2.alpha = 1.0;
			fader.graphic = canvas2;
			
			this.add(fader);
			
			fader.addTween(fadeTween, true);
		}
		
		public function startGameDelay():void
		{
			this.remove(fader);
			var delayTween:Tween = new Tween(60, Tween.ONESHOT, startGame);
			this.addTween(delayTween, true);
		}
		
		public function blinkFinish():void
		{
			fadeTween = new ColorTween(removeFader);
			fadeTween.tween(20, 0xffffff, 0xffffff, 1, 0);
			
			canvas2 = new Canvas(800, 640);
			canvas2.fill(new Rectangle(0, 0, 800, 480), 0xffffff);
			canvas2.alpha = 1.0;
			fader.graphic = canvas2;
			
			this.add(fader);
			
			fader.addTween(fadeTween, true);
		}
		
		public function removeFader():void
		{
			this.remove(fader);
		}
				
		public function removeWhatText():void
		{
			if (shadowText != null && shadowText.world == this)
				this.remove(shadowText);
		}
		
		public function startGame():void
		{	
			this.remove(logoSpt);
			playingCutscene = false;
			
			scenePlayer.actor.play("reading");
			
			scenePlayer.graphic.x = -200;
			sceneBoss.graphic.x = -200;
			
			this.remove(entCanvas);
			
			canvas1 = new Canvas(400, 480);
			canvas2 = new Canvas(400, 480);
			canvas2.x = 400;
			
			entCanvas = this.addGraphic(new Graphiclist(canvas1, canvas2));
			
			canvas1.drawGraphic(0, 0, scenePlayer.graphic);
			canvas2.drawGraphic(0, 0, sceneBoss.graphic);
			
			pitchField.text = "";
			
			textTimer = new TextWindow(100, 40, 0x000000, 3, 0x777777, 25, 0x00ff00 );
			textTimer.x = 700;
			textTimer.text = "0";
			this.add(textTimer);
			
			this.remove(pitchField);
			this.add(pitchField);
			
			buttonsArea = new Rectangle(0, 0, 800, 300);
			ideaSpeed = 1;
			storyButtons = new Array();			
			
			setNewOptions();
			
			musicFx = new Sfx(Sounds.BGM);
			musicFx.loop(1);
			
			counter = 0;
		}
		
		public function clearBaloons():void
		{
			for (var i:int = 0; i < storyButtons.length; i++)
				this.remove(storyButtons[i]);
		}
		
		public function setNewOptions():void
		{
			if (!WordDatabase.instance().finished())
			{
				clearBaloons();
				
				storyButtons = new Array();
				
				var currentWords:Array = WordDatabase.instance().getNextWords(6);
				pitchField.text += " "+currentWords[0]; //0 is the connector
				
				for (var i:int = 0; i < currentWords.length-1; i++)
				{
					storyButtons[i] = new IdeaButton();
					storyButtons[i].text = currentWords[i+1];
					this.add(storyButtons[i]);
					storyButtons[i].x = Math.random()*(buttonsArea.width-50);
					storyButtons[i].y = Math.random() * (buttonsArea.height - 20);
					storyButtons[i].speedVector = new Point(Math.random()*ideaSpeed, Math.random()*ideaSpeed);
				}
				
				ideaTime = counter;
			}
			else
			{
				onTimeOver();
			}
		}
		
		override public function update():void
		{
			if (playingCutscene)
				updateCutscene();
			else if (gameFinished)
				updateFinish();
			else 
				updateGame();
			
			super.update();
		}
		
		private function updateCutscene():void
		{
			if (story != null)
				story.update();
			else
				canvas2.alpha = fadeTween.alpha;
		}
		
		private function updateFinish():void
		{
		//	reset();
			if (Input.mousePressed)
			{
				if (replayBtn.collidePoint(replayBtn.x, replayBtn.y, Input.mouseX, Input.mouseY))
				{
					reset();
				}
			}
			
		}
		
		private function updateGame():void
		{
			counter++;
			if (counter > maxTime)
			{
				textTimer.text = String(10);
				onTimeOver();
			}
			else
			{
				textTimer.text = (Math.floor(10*(counter/30))/10).toString();
			}
			
			canvas1.drawGraphic(0, 0, scenePlayer.graphic);
			canvas2.drawGraphic(0, 0, sceneBoss.graphic);
			
			for (var i:int = storyButtons.length-1; i >= 0 ; i--)
			{
				if (Input.mousePressed)
				{
					if (storyButtons[i].collidePoint(storyButtons[i].x, storyButtons[i].y, Input.mouseX, Input.mouseY))
					{
						storyButtons[i].select(setNewOptions);
						
						for (var j:int = 0; j < storyButtons.length; j++)
						{
							if (i != j)
								storyButtons[j].visible = false;
						}
						
						pitchField.text += " " + storyButtons[i].text;
						playerFx.play(1);
						ideaSpeed += 1;
						checkLike(i);
						WordDatabase.instance().selectWord(storyButtons[i].text);
						WordDatabase.instance().iterate();
						
						break;
					}
				}
				
				storyButtons[i].x += storyButtons[i].speedVector.x;
				if ((storyButtons[i].speedVector.x > 0 && storyButtons[i].x + storyButtons[i].width > buttonsArea.width - storyButtons[i].width) ||
					(storyButtons[i].speedVector.x < 0 && storyButtons[i].x < 0)){
					storyButtons[i].speedVector.x = -storyButtons[i].speedVector.x;
				}
				
				storyButtons[i].y += storyButtons[i].speedVector.y;
				if ((storyButtons[i].speedVector.y > 0 && storyButtons[i].y + storyButtons[i].height > buttonsArea.height - storyButtons[i].height) ||
					(storyButtons[i].speedVector.y < 0 && storyButtons[i].y < 0)){
					storyButtons[i].speedVector.y = -storyButtons[i].speedVector.y;
				}				
			}
			
			if (counter > ideaTime + 80)
				addPreassure();
		}		
		
		private function checkLike(id:int):void
		{
			if (WordDatabase.instance().isLiked(storyButtons[id].text))
			{
				points++;
				if (points > 2)
					sceneBoss.actor.play("happy2");
				else
					sceneBoss.actor.play("happy");
					
				primFx.play(1);
			}
			else if (points < 1)
				sceneBoss.actor.play("bad");
		}
		
		private function addPreassure():void
		{
			sceneBoss.actor.play("scream");
			scenePlayer.actor.play("nervous");
			
			whatFx.play(1);
			
			shadowText = new ShadowedText(WordDatabase.instance().getCurrentConnector() + " WHAT?", 0xff0000, 40);
			
			shadowText.x = 600;
			shadowText.y = 100;
			
			this.add(shadowText);
			
			ideaTime = counter;
			for (var i:int = 0; i < storyButtons.length; i++)
			{
				storyButtons[i].speedVector.x *= 7;
				storyButtons[i].speedVector.y *= 7;
			}
		}
		
		public function onTimeOver():void
		{
			musicFx.stop();
			clearBaloons();
			gameFinished = true;
			playingCutscene = true;
			
			scenePlayer.graphic.x = 0;
			sceneBoss.graphic.x = 0;			
			
			this.remove(entCanvas);
			
			canvas1 = new Canvas(800, 480);
			entCanvas = this.addGraphic(canvas1);
			
			this.remove(pitchField);
			this.add(pitchField);
			
			story.setCanvas(canvas1);
			story.setTextWindow(pitchField);
			
			var shadowText2:ShadowedText;
			
			story.setScene(sceneBoss);
			story.queue("", "", 40);
			if (points >= 2)
			{
				shadowText = new ShadowedText("I LIKE IT!", 0x00ff44, 50);
				story.queueShadowText("happy2", shadowText, this, 100, Sounds.SFX_BOSSLOVE)
				story.queueScene(scenePlayer);
				shadowText2 = new ShadowedText("YOU DID IT!", 0x00FF00, 50);
				shadowText2.x = 300;
				shadowText2.y = 150;
				story.queueShadowText("happy", shadowText2, this, 40, Sounds.WIN);
				story.queue("", "And that's how your "+WordDatabase.instance().getFinalPhrase()+"made you a millionaire!", 300, null, finishMatch);	
			}
			else
			{
				shadowText = new ShadowedText("I HATE IT!", 0xff0000, 50);
				story.queueShadowText("scream", shadowText, this, 100, Sounds.SFX_BOSSHATE)
				story.queueScene(scenePlayer);
				shadowText2 = new ShadowedText("You're fired!", 0xff0000, 50);
				shadowText2.x = 300;
				shadowText2.y = 150;
				story.queueShadowText("sad", shadowText2, this, 40, Sounds.SFX_BOSSFIRED);
				story.queue("", "And that's how you became a hobo :(", 100, null, finishMatch);
			}
			
			shadowText.x = 300;
			shadowText.y = 100;
			
			blinkFinish();
			
			story.play();
		}
		
		public function finishMatch():void
		{
			/*Show score*/
			playingCutscene = false;
			this.add(replayBtn);
		}
		
		public function reset():void
		{
			trace("reset");
			FP.world = new MainGame();
		}
		
	}

}