package com.game 
{
	import flash.display.ActionScriptVersion;
	import flash.utils.Dictionary;
	/**
	 * ...
	 * @author ...
	 */
	public class WordDatabase 
	{
		[Embed(source = '../../../resources/worddata.dat', mimeType='application/octet-stream')]
		private static const DATA:Class;
		
		private const WORD:int = 0;
		private const FROM:int = 1;
		private const TO:int = 2;
		private const LIKES:int = 3;
		
		private var selectables:Dictionary;
		private var connections:Dictionary;
		private var currentPhrase:Array;
		private var likedWords:Array;
		private var selectedWords:Array;
		private var phrasePosition:int;
		
		private static var ptrDatabase:WordDatabase = null;
		
		public static function instance():WordDatabase
		{
			if (ptrDatabase == null)
				ptrDatabase = new WordDatabase();
				
			return ptrDatabase;
		}
		
		public function WordDatabase() 
		{
			
		}
		
		public function loadWords():void
		{
			var j:int;
			var file:String = new String(new DATA());
			var lines:Array = file.split("\n");
			
			selectables = new Dictionary();
			connections = new Dictionary();
			
			for (var i:int = 0; i < lines.length; i++)
			{
				if (lines[i].charAt(0) != '#') //not a comment
				{
					var fields:Array = lines[i].split(':');
					
					selectables[fields[WORD]] = new WordObject();
					selectables[fields[WORD]].text = fields[WORD];
					var toFields:Array = fields[TO].split(',');
					var toCamps:Array = new Array();
					for (j = 0; j < toFields.length; j++)
					{
						if (connections[toFields[j]] == null)
						{
							connections[toFields[j]] = new WordObject();
							connections[toFields[j]].text = toFields[j];
						}
							
						toCamps.push(connections[toFields[j]]);
					}
					
					selectables[fields[WORD]].to = toCamps;
					
					var fromFields:Array = fields[FROM].split(',');
					
					for (j = 0; j < fromFields.length; j++)
					{
						if (connections[fromFields[j]] == null)
						{
							connections[fromFields[j]] = new WordObject();
							connections[fromFields[j]].text = fromFields[j];
						}
						
						connections[fromFields[j]].to.push(selectables[fields[WORD]]);
					}
					
					fields[LIKES] = fields[LIKES].split("\r").join("");
					fields[LIKES] = fields[LIKES].split("\n").join("");
					
					selectables[fields[WORD]].likes = fields[LIKES].split(',');
					
				}
			}
			
		}
		
		public function buildPhrase(size:int, startingWord:String):void 
		{
			currentPhrase = new Array();
			var nextWord:String = startingWord;
			
			var usedConnections:Array = new Array();
			
			likedWords = new Array();
			
			for (var i:int = 0; i < size; i++)
			{
				currentPhrase.push(connections[nextWord]);
				usedConnections.push(nextWord);
				nextWord = connections[nextWord].getTo().text;
				currentPhrase.push(selectables[nextWord]);
				likedWords.push(selectables[nextWord].getLike());
				nextWord = selectables[nextWord].getTo(usedConnections).text;	
			}
			
			/*Print phrase for Debug*/
			//for (i = 0; i < currentPhrase.length; i++)
			//	trace(currentPhrase[i].text+" ")
			
			selectedWords = new Array();
			
			phrasePosition = 0;
		}
		
		public function selectWord(word:String):void
		{
			selectedWords.push(word);
		}
		
		public function getNextWords(size:int):Array
		{
			var words:Array = new Array();
			
			var tempArray:Array = currentPhrase[phrasePosition].to.slice();
			
			words[0] = currentPhrase[phrasePosition].text;
			words[1] = currentPhrase[phrasePosition+1].text;
			
			for (var i:int = 0; i < size-1 && tempArray.length > 0; )
			{
				var choosenWord:String = tempArray.splice(Math.floor(Math.random() * tempArray.length), 1)[0].text;
				var usedWord:Boolean = false;
				
				if (choosenWord == words[1])
				{
					usedWord = true;
				}
				else
				{	
					for (var j:int = 0; j < selectedWords.length; j++)
					{
						if (selectedWords[j] == choosenWord)
						{
							usedWord = true;
							break;
						}
					}
				}
				
				if (!usedWord)
				{
					words.push(choosenWord);
					i++;
				}
			}
			
			return words;
		}
		
		public function getCurrentConnector():String
		{
			return currentPhrase[phrasePosition].text;
		}
		
		public function iterate():void
		{
			phrasePosition+=2;
		}
		
		public function finished():Boolean
		{
			return (phrasePosition >= currentPhrase.length)
		}
		
		public function getFinalPhrase():String
		{
			var phrase:String = "";
			
			for (var i:int = 0; i < selectedWords.length; i++)
			{
				phrase += selectedWords[i] + " ";
				if ((i+1 < selectedWords.length) && ((i+1)*2 <= currentPhrase.length))
					phrase += currentPhrase[(i+1)*2].text+ " ";
			}
			
			return phrase;
			
		}
		
		public function getLikes():Array
		{
			return likedWords;
			var likeArray:Array = new Array();
			for (var i:int = 1; i < currentPhrase.length; i += 2)
			{
				likeArray.push(currentPhrase[i].getLike());
			}
			
			return likeArray;
		}
		
		public function isLiked(word:String):Boolean
		{
			for (var i:int = 0; i < selectables[word].likes.length; i++)
			{
				if (selectables[word].likes[i] == likedWords[phrasePosition / 2])
					return true;
			}
			
			return false;
		}
		
		public function getLikesPhrase(size:int):String
		{
			var phrase:String = "";
			var tempArray:Array = likedWords.slice();
			
			for (var i:int = 0; i < size-2; i++)
			{
				phrase += tempArray.splice(Math.floor(Math.random() * tempArray.length), 1)[0] + ", ";
			}
			
			phrase += tempArray.splice(Math.floor(Math.random() * tempArray.length), 1)[0] + " and ";
			phrase += tempArray.splice(Math.floor(Math.random() * tempArray.length), 1)[0];
			
			return phrase;
		}
		
	}

}