package com.hud 
{
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Canvas;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Graphiclist;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class TextWindow extends Entity
	{
		private var _text:String;
		private var textField:Text;
		private var border:Canvas;
		private var bg:Canvas;
		private var buffered:Boolean;
		private var bufferIndex:int;
		private var bufferTimer:int;
		
		public function TextWindow(w:Number, h:Number, color:uint, borderThick:uint, borderCol:uint, textSize:int = 18, textColor:int = 0xffffff) 
		{
			border = new Canvas(w, h);
			border.fill(new Rectangle(0, 0, w, h), borderCol);
			
			bg = new Canvas(w, h);
			bg.fill(new Rectangle(borderThick, borderThick, w-(borderThick*2), h-(borderThick*2)), color);
			
			textField = new Text("", 2, 2, { wordWrap:true, color: textColor, size: textSize } );
			textField.width = 780;
			textField.height = 100;
			
			buffered = false;
			
			setHitbox(bg.width, bg.height);
			
			this.graphic = new Graphiclist(border, bg,textField);
		}
		
		public function addTimedText(txt:String):void
		{
			textField.text = "";
			_text = txt;
			buffered = true;
			bufferTimer = 0;
			bufferIndex = 0;
		}
		
		public function set text(txt:String):void
		{
			buffered = false;
			_text = txt;
			textField.text = txt;
		}
		
		override public function update():void
		{
			if (buffered && bufferIndex < _text.length)
			{
				bufferTimer++;
				if (bufferTimer % 2 == 0)
				{
					textField.text += _text.charAt(bufferIndex);
					bufferIndex++;
				}
			}
			super.update();
		}
		
		public function get text():String
		{
			return _text;
		}		
	}

}